# -*- coding: utf-8 -*-
#
# UnivNautes
# Copyright (C) 2014  Entr'ouvert
#
# This program is free software: you can redistribute it and/or modify it under
# the terms of the GNU Affero General Public License as published by the Free
# Software Foundation, either version 3 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public License for more
# details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import os
from django.conf import settings
from django.views.static import serve as django_static_serve


def static_serve(request, path):
    # if path is "this/file.css", search for "captiveportal-idp-static-this-file.css"
    custom_path = 'captiveportal-idp-static-%s' % path.replace('/', '-')
    document_root = settings.CPELEMENTS
    if os.path.exists(os.path.join(document_root, custom_path)):
        return django_static_serve(request, custom_path, document_root=document_root)
    return django_static_serve(request, path, document_root=settings.STATIC_ROOT)
